/*    Copyright (C) 2005 XIAO, Gang of Universite de Nice - Sophia Antipolis
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	/* sysmask common definitions */

#define TOKENBUFLEN (512*1024)

#define confdir		"/etc/sysmask"
#define confdir_s	"/etc/sysmask/sys"
#define tokenfile	"/etc/sysmask/tokens"
#define rcfile		"/etc/sysmask/smkdrc"
#define passwdfile	"/etc/passwd"
#define errf		"/tmp/smkd.err"
#define logfile		"/var/log/smkd.log"
#define oldlog		"/var/log/smkd.log.old"
#define __NR_llseek	__NR__llseek
#define __NR_newselect	__NR__newselect
#define __NR_sysctl	__NR__sysctl
#define syscall_zero	"restart_syscall"

/* My libc-independent accelerated definitions. */
#define myisdigit(x) (x>='0' && x<='9')
#define myisalpha(x) ((x&~32)>='A' && (x&~32)<='Z')
#define myisalnum(x) (myisalpha(x) || myisdigit(x))
#define myisupper(x) (x>='A' && x<='Z')
#define myislower(x) (x>='a' && x<='z')
#define myislspace(x) (x==' ' || x=='\t')
	/* control characters are also considered as spaces */
#define myisspace(x) (x>0 && x<=' ')

	/* Refusals */
#define NAME_UNUSUAL	(1<<0)	/* unusual filenames */
#define NAME_SPACE	(1<<1)	/* embedded spaces */
#define NAME_NEWLINE	(1<<2)	/* new line chars, are also space */
#define NAME_CTRL	(1<<3)	/* control characters */
#define NAME_SPECIAL	(1<<4)	/* special chars: ()[]{}*?\<>|`'"&$ */
#define NAME_CHROOT	(1<<5)	/* name is chroot */
#define NAME_REALROOT	(1<<6)	/* name is real root */
#define NAME_HARDLINK	(1<<7)	/* name has hard link; this is passed to kernel */

#define NAME_SYMLINK	(1<<8)	/* name has symlink; this is passed to kernel */
#define NAME_BACKUP	(1<<9)	/* name contains directory backup (/../) */

	/* Options */
#define NAME_KEEPUID	(1<<21)	/* prohibit suid execve */
#define NAME_DEBUG2	(1<<22)	/* detailed debugging */
#define NAME_DEBUG	(1<<23)	/* activate debugging */
#define NAME_FOLLOW	SMKD_ANS_FOLLOW	/* follow symbolic links */
#define NAME_TICK	SMKD_ANS_TICK	/* trigger count advance */
#define NAME_KILL	SMKD_ANS_KILL	/* kill the process */

#define DEFTYPE_PRE	1
#define DEFTYPE_POST	2
#define DEFTYPE_COND	3
#define DEFTYPE_ACT	4

#define CALL_BACKUP	8999

