/*    Copyright (C) 2005 XIAO, Gang of Universite de Nice - Sophia Antipolis
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	/* smkd process bookkeeping. */

struct {
    pid_t pid;
    int start_time;	/* uniq identifier */
    time_t kill_time;
    int pad;
} killtab[KILL_MAX];

int killcnt;

void addkill(int delay)
{
    int i;
    for(i=0;i<killcnt;i++) {
	if(killtab[i].pid==request.pid) {
	    if(killtab[i].start_time!=request.start_time) {
		killtab[i].start_time=request.start_time;
		killtab[i].kill_time=now+delay;
		return;
	    }
	    if(killtab[i].kill_time>now+delay)
	      killtab[i].kill_time=now+delay;
	    return;
	}
    }
    if(i>=killcnt && killcnt<KILL_MAX) {
	killtab[i].pid=request.pid;
	killtab[i].start_time=request.start_time;
	killtab[i].kill_time=now+delay;
	killcnt++;
    }
}

void checkkill(void)
{
    int i;
    for(i=0;i<killcnt;i++) {
	if(killtab[i].kill_time>=now) continue;
	memset(&ans,0,sizeof(ans));
	ans.ind=SMKD_ANS_KILL;
	ans.smk.active.m1=killtab[i].pid;
	ans.smk.active.m2=killtab[i].start_time;
	sysmask(SMK_SMKDREP,&ans,sizeof(ans));
	memmove(&killtab[i],&killtab[i+1],(killcnt-i-1)*sizeof(killtab[0]));
	killcnt--;i--;
    }
}

